/*//////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  Copyright 1994-1999, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//      Ionel Daniel Stroe 
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~xmdv
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  XmdvTool Development Team: <matt@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT */

#include	<stdio.h>
#include	<math.h>
#include	<string.h>
#include	"x.h"

double		node[M][N];
double		minv[N], maxv[N]; 

void readHeader()
{
  int		i, n, m, b;
  char		line[256];
  double	tmin, tmax;

  scanf("%d %d\n", &n, &m);
  for (i=0; i<N; i++) scanf("%s", line);
  for (i=0; i<N; i++) scanf("%lf %lf %d", &tmin, &tmax, &b);
}

void readDataPoints()
{
  int		i, j;

  for(j=0; j<M; j++)
  for(i=0; i<N; i++)
  scanf("%lf", &node[j][i]);
}

void findMinMax()
{
  int		i, j;

  for (i=0; i<N; i++) minv[i] = maxv[i] = node[0][i];

  for(j=1; j<M; j++)
  for(i=0; i<N; i++)
  {
	if (node[j][i] > maxv[i]) maxv[i] = node[j][i];
	if (node[j][i] < minv[i]) minv[i] = node[j][i];
  }
}

void writeNormalizedDataPoints()
{
  int           i, j;

  for(j=0; j<M; j++, puts(""))
  for(i=0; i<N; i++)
  printf("%14.6lf ",
	minv[i] == maxv[i] ? 0. : (node[j][i]-minv[i])/(maxv[i]-minv[i]));
}

void main()
{
  readHeader();
  readDataPoints();
  findMinMax();
  writeNormalizedDataPoints();
}

